#include <stdio.h>
#include <cstdlib>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Box.H>
#include <FL/Fl.H>
#include <FL/fl_draw.H>

Fl_Box *output = 0;
static int W = 400;
static int H = 400;

void cb_test( void *d_ )
{
	Fl_Double_Window *win = (Fl_Double_Window *)d_;

	win->redraw();
	Fl::wait(0);

	// read the window image
	win->make_current();
	uchar *data = fl_read_image( 0, 0, 0, win->w(), win->h() );
	if ( data )
	{
		// show result in other window
		Fl_RGB_Image *image = new Fl_RGB_Image( data, win->w(), win->h(), 3 );
		image->alloc_array = 1;
		output->image( image );
		output->parent()->redraw(); // 1) output is garbage, when scale < 1!
		// 2) when initially starting with downscaling there is a crash when 50% is reached
	}

	Fl::repeat_timeout( 0.5, cb_test, d_ );
}

int main()
{
	Fl_Double_Window win( W, H, "main" );
	win.color( FL_BLUE );
	Fl_Box box( W/4, H/4, W/2, H/2 );
	box.box( FL_FLAT_BOX );
	box.color(FL_GREEN);
	win.end();
	win.show();

	Fl_Double_Window debug( win.w(), win.h(), "fl_read_image" );
	output = new Fl_Box( 0, 0, win.w(), win.h() );
	output->align( FL_ALIGN_IMAGE_BACKDROP );
	debug.end();
	debug.position( win.x() + win.w() + 20, win.y() + 100 );
	debug.show();

	Fl::add_timeout( 0.5, cb_test, &win );
	return Fl::run();
}
